{Coded in Free Pascal version 3.2.0}

{does 456 come before 666 when rolling a die?}

const
  NS = 500000;
var
  inputp  :  string;

procedure av_spins_2pattern(pattern : string);
var
  i,n,sum  :  longint;
  last3,
  dies     :  string;
  die      :  byte;
  average  :  real;
begin
  sum := 0;
  for i := 1 to NS do
    begin
    n := 0;
    last3 := '';
    while last3 <> pattern do
      begin
      die := random(6) + 1;
      str(die, dies);
      last3 := last3 + dies;
      if length(last3) > 3 then
        delete(last3, 1, 1);  
      inc(n);
      end;
    sum := sum + n;
    end; 
  {compute average}
  average := sum / NS;
  writeln('Average rolls until pattern is ', pattern, ' = ', round(average))
end;

procedure errorcheck;
var
  i : byte;
begin
  {check exactly 3 numbers input}
  if length(inputp) <> 3 then
    begin
    writeln('Input error : you must enter exactly 3 numbers.');
    writeln('Program terminating...');
    halt
    end;
  {now check numbers are in range}
  for i := 1 to 3 do
    if not(inputp[i] in ['1'..'6']) then
      begin
      writeln('Input error : one or more numbers out of range 1-6');
      writeln('Program terminating...');
      halt
      end;
end;

begin
  randomize;
  write('Input a pattern of 3 numbers (1-6) or 999 to quit : ');
  readln(inputp);
  while inputp <> '999' do 
    begin
    errorcheck;
    writeln('Processing pattern ', inputp, '...');
    av_spins_2pattern(inputp); 
    writeln; 
    write('Input a pattern of 3 numbers (1-6) or 999 to quit : ');
    readln(inputp);
    end;
end.
